searchNodes=[{"doc":"Tempus is a library to deal with timeslots. It aims to be a fast yet easy to use implementation of a schedule of any type, including but not limited to free/busy time schedules. The example of it might be a calendar software, where slots might be marked as free, or busy. It also allows simple arithmetics with schedules, like adding five days or subtracting 7 hours 30 minutes from now, considering busy slots.","ref":"Tempus.html","title":"Tempus","type":"module"},{"doc":"Adds an amount of units to the origin, considering slots given. Examples iex&gt; slots = [ ...&gt; ~D|2020-08-07| , ...&gt; ~D|2020-08-10| , ...&gt; ~D|2020-08-11| , ...&gt; ~D|2020-08-14| ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . add ( slots , ~U|2020-08-11 23:00:00Z| , - 10 * 60 + 1 , :second ) ~U[2020-08-09 23:50:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-12 00:09:00Z| , - 10 * 60 , :second ) ~U[2020-08-09 23:59:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-12 00:10:00Z| , - 10 * 60 , :second ) ~U[2020-08-12 00:00:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-12 00:10:00Z| , - 10 * 60 - 1 , :second ) ~U[2020-08-09 23:59:59Z] iex&gt; Tempus . add ( slots , ~U|2020-08-11 23:00:00Z| , 10 * 60 , :second ) ~U[2020-08-12 00:10:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-12 00:00:00Z| , 10 * 60 , :second ) ~U[2020-08-12 00:10:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-09 23:55:00Z| , 10 * 60 , :second ) ~U[2020-08-12 00:05:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-08 23:55:00Z| , 10 * 60 , :second ) ~U[2020-08-09 00:05:00Z] iex&gt; Tempus . add ( slots , ~U|2020-08-06 23:55:00Z| , 2 * 3600 * 24 + 10 * 60 , :second ) ~U[2020-08-12 00:05:00Z]","ref":"Tempus.html#add/4","title":"Tempus.add/4","type":"function"},{"doc":"Returns the reversed list of free days after origin. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-07| , count : 3 ) |&gt; hd ( ) ~D|2020-08-12| iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-07| , count : 3 , direction : :fwd ) |&gt; hd ( ) ~D|2020-08-12| iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-07| , count : - 3 , direction : :bwd ) |&gt; hd ( ) ~D|2020-08-12| iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-12| , count : - 4 ) |&gt; hd ( ) ~D|2020-08-06| iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-12| , count : 4 , direction : :bwd ) |&gt; hd ( ) ~D|2020-08-06| iex&gt; Tempus . days_add ( slots , origin : ~D|2020-08-12| , count : - 4 , direction : :fwd ) |&gt; hd ( ) ~D|2020-08-06|","ref":"Tempus.html#days_add/2","title":"Tempus.days_add/2","type":"function"},{"doc":"Returns the reversed list of free days after origin. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . days_ago ( slots , ~D|2020-08-07| , 0 ) [ ~D|2020-08-06| ] iex&gt; Tempus . days_ago ( slots , ~D|2020-08-12| , 4 ) |&gt; hd ( ) ~D|2020-08-06|","ref":"Tempus.html#days_ago/3","title":"Tempus.days_ago/3","type":"function"},{"doc":"Returns the reversed list of free days after origin. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . days_ahead ( slots , ~D|2020-08-07| , 0 ) [ ~D|2020-08-08| ] iex&gt; Tempus . days_ahead ( slots , ~D|2020-08-07| , 3 ) |&gt; hd ( ) ~D|2020-08-12|","ref":"Tempus.html#days_ahead/3","title":"Tempus.days_ahead/3","type":"function"},{"doc":"Drops slots at the beginning of the %Slots{} struct while fun returns a truthy value.","ref":"Tempus.html#drop_while/2","title":"Tempus.drop_while/2","type":"function"},{"doc":"Checks whether the slot is disjoined against slots. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . free? ( slots , ~D|2020-08-07| ) false iex&gt; Tempus . free? ( slots , ~D|2020-08-08| ) true iex&gt; Tempus . free? ( slots , ~U|2020-08-09T23:59:59.999999Z| ) true iex&gt; Tempus . free? ( slots , DateTime . add ( ~U|2020-08-09T23:59:59.999999Z| , 1 , :microsecond ) ) false","ref":"Tempus.html#free?/2","title":"Tempus.free?/2","type":"function"},{"doc":"Helper to instantiate slot from any known format, by wrapping the argument. Examples iex&gt; Tempus . guess ( &quot;2023-04-10&quot; ) { :ok , Tempus.Slot . wrap ( ~D[2023-04-10] ) } iex&gt; Tempus . guess ( &quot;2023-04-10T10:00:00Z&quot; ) { :ok , Tempus.Slot . wrap ( ~U[2023-04-10T10:00:00Z] ) } iex&gt; Tempus . guess ( &quot;20230410T235007.123+0230&quot; ) if Version . compare ( System . version ( ) , &quot;1.14.0&quot; ) == :lt do { :error , :invalid_format } else { :ok , Tempus.Slot . wrap ( ~U[2023-04-10T21:20:07.123Z] ) } end iex&gt; Tempus . guess ( &quot;2023-04-10-15&quot; ) { :error , :invalid_format }","ref":"Tempus.html#guess/1","title":"Tempus.guess/1","type":"function"},{"doc":"Helper to instantiate slot from any known format, by joining the arguments. Examples iex&gt; import Tempus.Sigils iex&gt; Tempus . guess ( &quot;2023-04-10&quot; , &quot;2023-04-12&quot; ) { :ok , ~I[2023-04-10 00:00:00.000000Z|2023-04-12 23:59:59.999999Z] } iex&gt; Tempus . guess ( &quot;2023-04-10T10:00:00Z&quot; , &quot;2023-04-12&quot; ) { :ok , ~I[2023-04-10 10:00:00Z|2023-04-12 23:59:59.999999Z] } iex&gt; Tempus . guess ( &quot;20230410T235007.123+0230&quot; , &quot;2023-04-12&quot; ) if Version . compare ( System . version ( ) , &quot;1.14.0&quot; ) == :lt do { :error , { :invalid_arguments , [ from : :invalid_format ] } } else { :ok , ~I[2023-04-10 21:20:07.123Z|2023-04-12 23:59:59.999999Z] } end iex&gt; Tempus . guess ( &quot;2023-04-10-15&quot; , :ok ) { :error , { :invalid_arguments , [ from : :invalid_format , to : :invalid_argument ] } }","ref":"Tempus.html#guess/2","title":"Tempus.guess/2","type":"function"},{"doc":"Returns the next busy slot from the slots passed as a first argument, that immediately follows origin . If slots are overlapped, the overlapped one gets returned. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-08 23:00:00Z| , to : ~U|2020-08-09 12:00:00Z| } ) % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-07 11:00:00Z| , to : ~U|2020-08-07 12:00:00Z| } , count : 2 ) |&gt; hd ( ) % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-07 11:00:00Z| , to : ~U|2020-08-08 12:00:00Z| } ) % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-07 11:00:00Z| , to : ~U|2020-08-10 12:00:00Z| } ) % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : ~D|2020-08-07| ) % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : ~D|2020-08-08| ) % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : ~D|2020-08-08| , direction : :bwd ) % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : ~D|2020-08-10| , direction : :bwd ) % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-11 11:00:00Z| , to : ~U|2020-08-11 12:00:00Z| } ) nil iex&gt; Tempus . next_busy ( slots , origin : % Tempus.Slot { from : ~U|2020-08-06 11:00:00Z| , to : ~U|2020-08-06 12:00:00Z| } , direction : :bwd ) nil iex&gt; Tempus . next_busy ( % Tempus.Slots { } ) nil","ref":"Tempus.html#next_busy/2","title":"Tempus.next_busy/2","type":"function"},{"doc":"Returns the next free slot from the slots passed as a first argument, that immediately follows origin . If slots are overlapped, the overlapped one gets returned. Examples iex&gt; import Tempus.Sigils iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-12| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-14| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) iex&gt; Tempus . next_free ( slots , origin : % Tempus.Slot { from : ~U|2020-08-08 23:00:00Z| , to : ~U|2020-08-09 12:00:00Z| } ) ~I[2020-08-08 00:00:00.000000Z → 2020-08-09 23:59:59.999999Z] iex&gt; Tempus . next_free ( slots , origin : % Tempus.Slot { from : ~U|2020-08-06 11:00:00Z| , to : ~U|2020-08-06 12:00:00Z| } ) ~I[∞ → 2020-08-06 23:59:59.999999Z]nu iex&gt; Tempus . next_free ( slots , origin : ~U|2020-08-13 01:00:00.000000Z| ) ~I[2020-08-13 00:00:00.000000Z → 2020-08-13 23:59:59.999999Z] iex&gt; Tempus . next_free ( slots , origin : ~D|2020-08-13| ) ~I[2020-08-13 00:00:00.000000Z → 2020-08-13 23:59:59.999999Z] iex&gt; Tempus . next_free ( slots , origin : ~D|2020-08-14| ) ~I[2020-08-15 00:00:00.000000Z → ∞]un","ref":"Tempus.html#next_free/2","title":"Tempus.next_free/2","type":"function"},{"doc":"Slices the %Slots{} based on origins from and to and an optional type (default: :reluctant .) Returns sliced %Slots{} back.","ref":"Tempus.html#slice/4","title":"Tempus.slice/4","type":"function"},{"doc":"See Tempus.Slot.new/2 .","ref":"Tempus.html#slot/2","title":"Tempus.slot/2","type":"function"},{"doc":"See Tempus.Slot.new!/2 .","ref":"Tempus.html#slot!/2","title":"Tempus.slot!/2","type":"function"},{"doc":"Syntactic sugar for |&gt; Enum.into(%Slots{}) . Examples iex&gt; [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-12| ) ...&gt; ] |&gt; Tempus . slots ( ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 00:00:00.000000Z] , to : ~U[2020-08-12 23:59:59.999999Z] } ] } }","ref":"Tempus.html#slots/1","title":"Tempus.slots/1","type":"function"},{"doc":"Takes slots at the beginning of the %Slots{} struct while fun returns a truthy value.","ref":"Tempus.html#take_while/2","title":"Tempus.take_while/2","type":"function"},{"doc":"Number of slots ( :stream means lazy folding, unknown upfront)","ref":"Tempus.html#t:count/0","title":"Tempus.count/0","type":"type"},{"doc":"Direction for slots navigation","ref":"Tempus.html#t:direction/0","title":"Tempus.direction/0","type":"type"},{"doc":"Navigation option","ref":"Tempus.html#t:option/0","title":"Tempus.option/0","type":"type"},{"doc":"Argument containing navigation options","ref":"Tempus.html#t:options/0","title":"Tempus.options/0","type":"type"},{"doc":"The type defining how slicing is to be applied. When :greedy , overlapping boundary slots would be included, :reluctant would take only those fully contained in the interval.","ref":"Tempus.html#t:slice_type/0","title":"Tempus.slice_type/0","type":"type"},{"doc":"The bunch of functions expected to be implemented by Tempus.Slots implementations.","ref":"Tempus.Slots.Behaviour.html","title":"Tempus.Slots.Behaviour","type":"behaviour"},{"doc":"Creates a new instance, which is also usually an identity element","ref":"Tempus.Slots.Behaviour.html#c:new/0","title":"Tempus.Slots.Behaviour.new/0","type":"callback"},{"doc":"The protocol to implement for the ordered collection of slots.","ref":"Tempus.Slots.Group.html","title":"Tempus.Slots.Group","type":"protocol"},{"doc":"Adds a single t:Slot.t() instance to this t:Slots.t(t()) implementation. If merge/3 implementation returns {:error, __MODULE__} , this function would be used to add elements one by one through reduce/3 .","ref":"Tempus.Slots.Group.html#add/3","title":"Tempus.Slots.Group.add/3","type":"function"},{"doc":"Flattens the implementation, returning the list back.","ref":"Tempus.Slots.Group.html#flatten/2","title":"Tempus.Slots.Group.flatten/2","type":"function"},{"doc":"The function returning the identity element, which can be merged into each and every implementation without changing it.","ref":"Tempus.Slots.Group.html#identity/1","title":"Tempus.Slots.Group.identity/1","type":"function"},{"doc":"Efficient implementation of inversing slots. If this function returns {:error, __MODULE__} , the reduce/3 will be used instead.","ref":"Tempus.Slots.Group.html#inverse/2","title":"Tempus.Slots.Group.inverse/2","type":"function"},{"doc":"Efficient implementation of merging slots. If this function returns {:error, __MODULE__} , the reduce/3 will be used instead.","ref":"Tempus.Slots.Group.html#merge/3","title":"Tempus.Slots.Group.merge/3","type":"function"},{"doc":"Efficient implementation of splitting slots. If this function returns {:error, __MODULE__} , the reduce/3 will be used instead.","ref":"Tempus.Slots.Group.html#split/3","title":"Tempus.Slots.Group.split/3","type":"function"},{"doc":"","ref":"Tempus.Slots.Group.html#t:t/0","title":"Tempus.Slots.Group.t/0","type":"type"},{"doc":"Handy guards to simplify pattern matching slots","ref":"Tempus.Guards.html","title":"Tempus.Guards","type":"module"},{"doc":"Guard to compare two instances of Tempus.Slot.origin/0 Examples iex&gt; import Tempus.Guards , only : [ is_coming_before : 2 ] ...&gt; is_coming_before ( ~D[2023-04-10] , ~U[2023-04-11T00:00:00.000000Z] ) true ...&gt; is_coming_before ( ~D[2023-04-10] , ~D[2023-04-10] ) false","ref":"Tempus.Guards.html#is_coming_before/2","title":"Tempus.Guards.is_coming_before/2","type":"macro"},{"doc":"Guard to validate the slot covers the origin passed as the first argument Examples iex&gt; import Tempus.Guards , only : [ is_covered : 2 ] ...&gt; import Tempus.Sigils ...&gt; { from , to } = { ~U[2023-04-10 00:00:00Z] , ~U[2023-04-10 00:59:59Z] } ...&gt; s = % Tempus.Slot { from : from , to : to } ...&gt; is_covered ( from , s ) and is_covered ( to , s ) true ...&gt; s1 = ~I[2023-04-10 00:00:00Z|2023-04-11 00:00:00Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-10| ) ...&gt; is_covered ( s1 , s2 ) false ...&gt; s1 = ~I[2023-04-10 00:00:00Z|2023-04-11 00:00:00Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-10| ) ...&gt; is_covered ( s1 , s2 ) false","ref":"Tempus.Guards.html#is_covered/2","title":"Tempus.Guards.is_covered/2","type":"macro"},{"doc":"Guard to validate one slot ovelaps another Examples iex&gt; import Tempus.Guards , only : [ is_joint : 2 ] ...&gt; import Tempus.Sigils ...&gt; s1 = ~I[2023-04-09 23:00:00Z|2023-04-10 00:59:59Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-10| ) ...&gt; is_joint ( s1 , s2 ) true ...&gt; s1 = ~I[2023-04-09 23:00:00Z|2023-04-10 00:00:00Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-10| ) ...&gt; is_joint ( s1 , s2 ) true","ref":"Tempus.Guards.html#is_joint/2","title":"Tempus.Guards.is_joint/2","type":"macro"},{"doc":"Guard to validate that the term given is actually a Tempus.Slot.origin/0 or a function which might be used as a slot locator. Examples iex&gt; import Tempus.Guards , only : [ is_locator : 1 , is_coming_before : 2 ] ...&gt; is_locator ( Date . utc_today ( ) ) true ...&gt; is_locator ( &amp; Date . utc_today ( ) |&gt; Tempus.Slot . wrap ( ) |&gt; is_coming_before ( &amp;1 ) ) true ...&gt; is_locator ( true ) false","ref":"Tempus.Guards.html#is_locator/1","title":"Tempus.Guards.is_locator/1","type":"macro"},{"doc":"Guard to validate that the term given is actually a Tempus.Slot.origin/0 Examples iex&gt; import Tempus.Guards , only : [ is_origin : 1 ] ...&gt; is_origin ( Date . utc_today ( ) ) true ...&gt; is_origin ( nil ) true ...&gt; is_origin ( :ok ) false","ref":"Tempus.Guards.html#is_origin/1","title":"Tempus.Guards.is_origin/1","type":"macro"},{"doc":"Guard to validate whether the DateTime.t/0 given as the first argument is the border of the slot.","ref":"Tempus.Guards.html#is_slot_border/2","title":"Tempus.Guards.is_slot_border/2","type":"macro"},{"doc":"Guard to validate whether two slots are equal Examples iex&gt; import Tempus.Guards , only : [ is_slot_equal : 2 ] ...&gt; import Tempus.Sigils ...&gt; s1 = ~I[2023-04-09 00:00:00Z|2023-04-09 23:59:59.999999Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-09| ) ...&gt; s3 = ~I[2023-04-09 00:00:00Z|2023-04-09 23:59:59Z] ...&gt; is_slot_equal ( s1 , s1 ) true ...&gt; is_slot_equal ( s1 , s2 ) true ...&gt; is_slot_equal ( s1 , s3 ) false","ref":"Tempus.Guards.html#is_slot_equal/2","title":"Tempus.Guards.is_slot_equal/2","type":"macro"},{"doc":"Guard to validate whether the slot is nil (has neither end set.)","ref":"Tempus.Guards.html#is_slot_nil/1","title":"Tempus.Guards.is_slot_nil/1","type":"macro"},{"doc":"Guard to validate whether the slot is open (has either end not set) Please note, that the slot having both ends set to nil is considered a special case and is not reported as open .","ref":"Tempus.Guards.html#is_slot_open/1","title":"Tempus.Guards.is_slot_open/1","type":"macro"},{"doc":"Helper to validate one slot overlaps another in delta. Unlike guards, this function does not expect arguments in the correct order, and would return true if the slots overlap even if s2 comes before s1 . Examples iex&gt; import Tempus.Guards , only : [ joint_in_delta? : 3 ] ...&gt; import Tempus.Sigils ...&gt; s1 = ~I[2023-04-09 23:00:00Z|2023-04-09 23:59:59Z] ...&gt; s2 = Tempus.Slot . wrap ( ~D|2023-04-10| ) ...&gt; joint_in_delta? ( s1 , s2 , 1 ) true ...&gt; joint_in_delta? ( s2 , s1 , 1 ) true ...&gt; joint_in_delta? ( s1 , s2 , microsecond : 500 ) false","ref":"Tempus.Guards.html#joint_in_delta?/3","title":"Tempus.Guards.joint_in_delta?/3","type":"function"},{"doc":"Handy sigils to instantiate Tempus.Slot and Tempus.Slots","ref":"Tempus.Sigils.html","title":"Tempus.Sigils","type":"module"},{"doc":"Parses the sigil-like binary representation of a Tempus.Slot . Examples iex&gt; Tempus.Sigils . parse ( &quot;2021-03-30T06:35:40Z|2021-03-30T06:36:00Z&quot; ) { :ok , % Tempus.Slot { from : ~U[2021-03-30 06:35:40Z] , to : ~U[2021-03-30 06:36:00Z] } }","ref":"Tempus.Sigils.html#parse/1","title":"Tempus.Sigils.parse/1","type":"function"},{"doc":"Handles the sigil ~I for Tempus.Slot . It returns a slot without interpolations and without escape characters, except for the escaping of the closing sigil character itself. Allowed separators: | , → , -&gt; , .. (might be surrounded by spaces) Allowed modifiers: none — expects two instances of DateTime single letter , one of d , t , u — both values are expected to be of that type any combination of two letters d , t , u  — the values are treated respectively g — the value types are to be guessed Examples iex&gt; import Tempus.Sigils iex&gt; ~I(2021-03-30T06:35:40Z|2021-03-30T06:36:00Z) % Tempus.Slot { from : ~U[2021-03-30 06:35:40Z] , to : ~U[2021-03-30 06:36:00Z] } iex&gt; ~I(2021-03-30 → 2021-03-31)d % Tempus.Slot { from : ~U[2021-03-30 00:00:00.000000Z] , to : ~U[2021-03-31 23:59:59.999999Z] } iex&gt; ~I(2021-03-30)d % Tempus.Slot { from : ~U[2021-03-30 00:00:00.000000Z] , to : ~U[2021-03-30 23:59:59.999999Z] } iex&gt; ~I(2021-03-30 06:35:40Z .. 2021-03-30 06:36:00Z)g % Tempus.Slot { from : ~U[2021-03-30 06:35:40Z] , to : ~U[2021-03-30 06:36:00Z] }","ref":"Tempus.Sigils.html#sigil_I/2","title":"Tempus.Sigils.sigil_I/2","type":"macro"},{"doc":"Declares a timeslot and exports functions to check whether the given date and/or datetime is covered by this slot or not. This module probably should not be called directly.","ref":"Tempus.Slot.html","title":"Tempus.Slot","type":"module"},{"doc":"Compares two slot structs. Returns :gt if first slot is strictly later than the second and :lt for vice versa. NB :eq is returned not only if slots are equal, but also when they are overlapped. Might be used in Enum.sort/2 .","ref":"Tempus.Slot.html#compare/3","title":"Tempus.Slot.compare/3","type":"function"},{"doc":"Checks whether to Slot covers the data/datetime passed as a second argument. Examples iex&gt; dt_between = ~U|2015-09-30 01:00:00Z| ...&gt; dt_from = ~U|2015-09-30 00:00:00Z| ...&gt; dt_to = ~U|2015-10-01 01:00:00Z| ...&gt; d_from = Date . from_iso8601! ( &quot;2015-09-30&quot; ) ...&gt; d_to = Date . from_iso8601! ( &quot;2015-10-01&quot; ) iex&gt; slot = % Tempus.Slot { from : dt_from , to : dt_to } iex&gt; Tempus.Slot . cover? ( slot , dt_between ) true iex&gt; Tempus.Slot . cover? ( slot , dt_to ) true iex&gt; Tempus.Slot . cover? ( slot , dt_to , true ) false iex&gt; Tempus.Slot . cover? ( slot , d_from ) true iex&gt; Tempus.Slot . cover? ( slot , d_from , true ) false iex&gt; Tempus.Slot . cover? ( slot , d_to ) false","ref":"Tempus.Slot.html#cover?/3","title":"Tempus.Slot.cover?/3","type":"function"},{"doc":"Returns true if two slots are disjoined, false otherwise. Examples iex&gt; slot = % Tempus.Slot { from : ~U|2015-09-01 00:00:00Z| , to : ~U|2015-10-01 00:00:00Z| } iex&gt; inner = % Tempus.Slot { from : ~U|2015-09-01 00:00:00Z| , to : ~U|2015-09-01 01:00:00Z| } iex&gt; Tempus.Slot . disjoint? ( slot , inner ) false iex&gt; inner = % Tempus.Slot { from : ~U|2015-09-01 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| } iex&gt; Tempus.Slot . disjoint? ( slot , inner ) false iex&gt; outer = % Tempus.Slot { from : ~U|2015-10-01 00:00:01Z| , to : ~U|2015-10-01 01:00:00Z| } iex&gt; Tempus.Slot . disjoint? ( slot , outer ) true","ref":"Tempus.Slot.html#disjoint?/2","title":"Tempus.Slot.disjoint?/2","type":"function"},{"doc":"Calculates the duration of a slot in units given as a second parameter (default: :second .) Example iex&gt; ~D|2020-09-03| |&gt; Tempus.Slot . wrap ( ) |&gt; Tempus.Slot . duration ( ) 86400","ref":"Tempus.Slot.html#duration/2","title":"Tempus.Slot.duration/2","type":"function"},{"doc":"Intersects slots to the minimal covered timeslice. Example iex&gt; Tempus.Slot . intersect ( [ Tempus.Slot . wrap ( ~D|2020-09-30| ) , ...&gt; % Tempus.Slot { from : ~U|2020-09-30 23:00:00Z| , to : ~U|2020-10-02 00:00:00Z| } ] ) % Tempus.Slot { from : ~U[2020-09-30 23:00:00Z] , to : ~U[2020-09-30 23:59:59.999999Z] }","ref":"Tempus.Slot.html#intersect/1","title":"Tempus.Slot.intersect/1","type":"function"},{"doc":"Joins slots to the maximal covered timeslice. Example iex&gt; Tempus.Slot . join ( [ Tempus.Slot . wrap ( ~D|2020-09-30| ) , Tempus.Slot . wrap ( ~D|2020-10-02| ) ] ) % Tempus.Slot { from : ~U[2020-09-30 00:00:00.000000Z] , to : ~U[2020-10-02 23:59:59.999999Z] } iex&gt; Tempus.Slot . join ( [ ~D|2020-09-30| , ~D|2020-10-02| ] ) % Tempus.Slot { from : ~U[2020-09-30 00:00:00.000000Z] , to : ~U[2020-10-02 23:59:59.999999Z] }","ref":"Tempus.Slot.html#join/1","title":"Tempus.Slot.join/1","type":"function"},{"doc":"Joins two slots to the maximal covered timeslice. Example iex&gt; Tempus.Slot . join ( Tempus.Slot . wrap ( ~D|2020-09-30| ) , Tempus.Slot . wrap ( ~D|2020-10-02| ) ) % Tempus.Slot { from : ~U[2020-09-30 00:00:00.000000Z] , to : ~U[2020-10-02 23:59:59.999999Z] } iex&gt; Tempus.Slot . join ( ~D|2020-09-30| , ~D|2020-10-02| ) % Tempus.Slot { from : ~U[2020-09-30 00:00:00.000000Z] , to : ~U[2020-10-02 23:59:59.999999Z] }","ref":"Tempus.Slot.html#join/2","title":"Tempus.Slot.join/2","type":"function"},{"doc":"Returns true if two slots are neighbours, false otherwise. Examples iex&gt; slot = % Tempus.Slot { from : ~U|2015-09-01 00:00:00Z| , to : ~U|2015-10-01 23:59:59Z| } iex&gt; Tempus.Slot . neighbour? ( slot , Tempus.Slot . wrap ( ~D|2015-10-02| ) ) true iex&gt; Tempus.Slot . neighbour? ( slot , Tempus.Slot . wrap ( ~D|2015-08-31| ) ) true iex&gt; Tempus.Slot . neighbour? ( slot , Tempus.Slot . wrap ( ~D|2015-10-01| ) ) false iex&gt; Tempus.Slot . neighbour? ( slot , Tempus.Slot . wrap ( ~D|2015-10-03| ) ) false","ref":"Tempus.Slot.html#neighbour?/2","title":"Tempus.Slot.neighbour?/2","type":"function"},{"doc":"Creates new slot using arg[:from] as a starting origin and arg[:to] and an ending origin. Examples iex&gt; Tempus.Slot . new ( from : ~U|2015-09-30 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| ) { :ok , % Tempus.Slot { from : ~U|2015-09-30 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| } } iex&gt; Tempus.Slot . new ( %{ from : ~D|2015-09-30| , to : ~U|2015-10-01T12:00:00Z| } ) { :ok , % Tempus.Slot { from : ~U|2015-09-30 00:00:00.000000Z| , to : ~U|2015-10-01 12:00:00Z| } }","ref":"Tempus.Slot.html#new/1","title":"Tempus.Slot.new/1","type":"function"},{"doc":"Creates new slot using from as a starting origin and to and an ending origin. See new/1 for more readable implementation. Examples iex&gt; Tempus.Slot . new ( ~U|2015-09-30 00:00:00Z| , ~U|2015-10-01 01:00:00Z| ) { :ok , % Tempus.Slot { from : ~U|2015-09-30 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| } } iex&gt; Tempus.Slot . new ( ~D|2015-09-30| , ~U|2015-10-01T12:00:00Z| ) { :ok , % Tempus.Slot { from : ~U|2015-09-30 00:00:00.000000Z| , to : ~U|2015-10-01 12:00:00Z| } } iex&gt; Tempus.Slot . new ( :ok , :ok ) { :error , :invalid_input }","ref":"Tempus.Slot.html#new/2","title":"Tempus.Slot.new/2","type":"function"},{"doc":"Creates new slot using from as a starting origin and to and an ending origin. Unlike new/1 , this function raises on malformed input. Examples iex&gt; Tempus.Slot . new! ( ~U|2015-09-30 00:00:00Z| , ~U|2015-10-01 01:00:00Z| ) % Tempus.Slot { from : ~U|2015-09-30 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| } iex&gt; Tempus.Slot . new! ( ~D|2015-09-30| , ~U|2015-10-01T12:00:00Z| ) % Tempus.Slot { from : ~U|2015-09-30 00:00:00.000000Z| , to : ~U|2015-10-01 12:00:00Z| } iex&gt; Tempus.Slot . new! ( :ok , :ok ) ** (ArgumentError) malformed from/to argument, expected `origin`","ref":"Tempus.Slot.html#new!/2","title":"Tempus.Slot.new!/2","type":"function"},{"doc":"Shifts both from and to values to UTC zone. Examples slot = % Tempus.Slot { from : DateTime . from_naive! ( ~N|2018-01-05 21:00:00| , &quot;America/New_York&quot; ) , to : DateTime . from_naive! ( ~N|2018-01-08 08:59:59| , &quot;Australia/Sydney&quot; ) } #⇒ %Tempus.Slot{from: ~U[2018-01-06 02:00:00Z], to: ~U[2018-01-07 21:59:59Z]}","ref":"Tempus.Slot.html#shift_tz/3","title":"Tempus.Slot.shift_tz/3","type":"function"},{"doc":"Compares two slot structs. The same as compare/2 , but returns :joint if the slots are overlapped.","ref":"Tempus.Slot.html#strict_compare/2","title":"Tempus.Slot.strict_compare/2","type":"function"},{"doc":"Checks whether the Slot is valid (to &gt; from) or not. Examples iex&gt; slot = % Tempus.Slot { from : ~U|2015-09-30 00:00:00Z| , to : ~U|2015-10-01 01:00:00Z| } iex&gt; Tempus.Slot . valid? ( slot ) true iex&gt; Tempus.Slot . valid? ( % Tempus.Slot { from : slot . to , to : slot . from } ) false","ref":"Tempus.Slot.html#valid?/1","title":"Tempus.Slot.valid?/1","type":"function"},{"doc":"Helper macro to pattern-match void slots.","ref":"Tempus.Slot.html#void/0","title":"Tempus.Slot.void/0","type":"macro"},{"doc":"Wraps the argument into a slot. For DateTime it’d be a single microsecond. For a Date , it would be the whole day, starting at 00:00:00.000000 and ending at ` 23 : 59 : 59 : 999999 ` . Examples iex&gt; Tempus.Slot . wrap ( ~D|2020-08-06| ) % Tempus.Slot { from : ~U[2020-08-06 00:00:00.000000Z] , to : ~U[2020-08-06 23:59:59.999999Z] }","ref":"Tempus.Slot.html#wrap/2","title":"Tempus.Slot.wrap/2","type":"function"},{"doc":"Splits the slot given asa first argument to two on borders given as a second slot. Examples iex&gt; outer = Tempus.Slot . wrap ( ~D[2023-04-12] ) ...&gt; { :ok , inner } = Tempus.Slot . new ( ~U[2023-04-12 12:00:00Z] , ~U[2023-04-12 13:00:00Z] ) iex&gt; Tempus.Slot . xor ( outer , inner ) [ % Tempus.Slot { from : ~U[2023-04-12 00:00:00.000000Z] , to : ~U[2023-04-12 12:00:00Z] } , % Tempus.Slot { from : ~U[2023-04-12 13:00:00Z] , to : ~U[2023-04-12 23:59:59.999999Z] } ] iex&gt; Tempus.Slot . xor ( outer , inner ) == Tempus.Slot . xor ( inner , outer ) true","ref":"Tempus.Slot.html#xor/2","title":"Tempus.Slot.xor/2","type":"function"},{"doc":"The origin used in comparisons and calculations","ref":"Tempus.Slot.html#t:origin/0","title":"Tempus.Slot.origin/0","type":"type"},{"doc":"A timeslot to be used in Tempus","ref":"Tempus.Slot.html#t:t/0","title":"Tempus.Slot.t/0","type":"type"},{"doc":"The interface to deal with the implementation of Tempus.Slot ordered collection. Comes with several default implementations, backed up by ordered list of slots, by Stream , by AVLTree ¹, and by Year-Month² tree. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ] ...&gt; Enum . into ( slots , % Tempus.Slots { } ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] } } iex&gt; Enum . map ( slots , &amp; &amp;1 . from ) [ ~U[2020-08-07 00:00:00.000000Z] , ~U[2020-08-10 00:00:00.000000Z] , ~U[2020-08-07 01:00:00Z] ]","ref":"Tempus.Slots.html","title":"Tempus.Slots","type":"module"},{"doc":"Adds another slot to the slots collection. Joins slots intersecting with the new one, if any. Example iex&gt; Tempus.Slots . add ( % Tempus.Slots { } , Tempus.Slot . wrap ( ~D|2020-08-07| ) ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } ] } } iex&gt; % Tempus.Slots { } ...&gt; |&gt; Tempus.Slots . add ( Tempus.Slot . wrap ( ~D|2020-08-07| ) ) ...&gt; |&gt; Tempus.Slots . add ( Tempus.Slot . wrap ( ~D|2020-08-10| ) ) ...&gt; |&gt; Tempus.Slots . add ( % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] } }","ref":"Tempus.Slots.html#add/3","title":"Tempus.Slots.add/3","type":"function"},{"doc":"Returns the number of slots","ref":"Tempus.Slots.html#count/1","title":"Tempus.Slots.count/1","type":"function"},{"doc":"","ref":"Tempus.Slots.html#drop_until/3","title":"Tempus.Slots.drop_until/3","type":"function"},{"doc":"","ref":"Tempus.Slots.html#flatten/2","title":"Tempus.Slots.flatten/2","type":"function"},{"doc":"Inverses Slots returning the new Slots instance with slots set where there were blanks. Example iex&gt; [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-08| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-12| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) ...&gt; |&gt; Tempus.Slots . inverse ( ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : nil , to : ~U[2020-08-06 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-13 00:00:00.000000Z] , to : nil } ] } } iex&gt; [ ...&gt; % Tempus.Slot { to : ~U[2020-08-08 23:59:59.999999Z] } , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { from : ~U[2020-08-12 00:00:00.000000Z] } ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) ...&gt; |&gt; Tempus.Slots . inverse ( ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } ] } }","ref":"Tempus.Slots.html#inverse/2","title":"Tempus.Slots.inverse/2","type":"function"},{"doc":"Merges many slots into the first element in the list given as an argument. Other arguments might be enumerables, the first one must be a Tempus.Slots instance. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots { } ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] } } iex&gt; other = [ ...&gt; % Tempus.Slot { from : ~U|2020-08-07 23:00:00Z| , to : ~U|2020-08-08 12:00:00Z| } , ...&gt; % Tempus.Slot { from : ~U|2020-08-12 23:00:00Z| , to : ~U|2020-08-12 23:30:00Z| } ...&gt; ] iex&gt; Tempus.Slots . merge ( [ slots , other ] ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 12:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 23:00:00Z] , to : ~U[2020-08-12 23:30:00Z] } ] } } iex&gt; Tempus.Slots . merge ( [ slots , Tempus.Slots . wrap ( other , Tempus.Slots.Stream ) ] ) |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 12:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 23:00:00Z] , to : ~U[2020-08-12 23:30:00Z] } ]","ref":"Tempus.Slots.html#merge/3","title":"Tempus.Slots.merge/3","type":"function"},{"doc":"Creates an instance of slots, using a backend given as a parameter.","ref":"Tempus.Slots.html#new/2","title":"Tempus.Slots.new/2","type":"function"},{"doc":"","ref":"Tempus.Slots.html#span/3","title":"Tempus.Slots.span/3","type":"function"},{"doc":"","ref":"Tempus.Slots.html#split/3","title":"Tempus.Slots.split/3","type":"function"},{"doc":"","ref":"Tempus.Slots.html#take_until/3","title":"Tempus.Slots.take_until/3","type":"function"},{"doc":"Wraps the argument into a slots instance. For nil it’d be an empty slots. For everything else it’d call Slot.wrap/1 on an argument and add it to empty slots. Examples iex&gt; Tempus.Slots . wrap ( ~D|2020-08-06| ) % Tempus.Slots { slots : % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-06 00:00:00.000000Z] , to : ~U[2020-08-06 23:59:59.999999Z] } ] } }","ref":"Tempus.Slots.html#wrap/2","title":"Tempus.Slots.wrap/2","type":"function"},{"doc":"","ref":"Tempus.Slots.html#t:container/0","title":"Tempus.Slots.container/0","type":"type"},{"doc":"","ref":"Tempus.Slots.html#t:implementation/1","title":"Tempus.Slots.implementation/1","type":"type"},{"doc":"","ref":"Tempus.Slots.html#t:implementation/2","title":"Tempus.Slots.implementation/2","type":"type"},{"doc":"The type to use in navigation and/or rewinding slots enumerables","ref":"Tempus.Slots.html#t:locator/0","title":"Tempus.Slots.locator/0","type":"type"},{"doc":"","ref":"Tempus.Slots.html#t:t/0","title":"Tempus.Slots.t/0","type":"type"},{"doc":"","ref":"Tempus.Slots.html#t:t/1","title":"Tempus.Slots.t/1","type":"type"},{"doc":"","ref":"Tempus.Slots.html#t:t/2","title":"Tempus.Slots.t/2","type":"type"},{"doc":"The default List implementation of Tempus.Slots ordered collection. Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ] ...&gt; Enum . into ( slots , % Tempus.Slots.List { } ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] } iex&gt; Enum . map ( slots , &amp; &amp;1 . from ) [ ~U[2020-08-07 00:00:00.000000Z] , ~U[2020-08-10 00:00:00.000000Z] , ~U[2020-08-07 01:00:00Z] ]","ref":"Tempus.Slots.List.html","title":"Tempus.Slots.List","type":"module"},{"doc":"Adds another slot to the slots collection implemented as list. Joins slots intersecting with the new one, if any. Example iex&gt; Tempus.Slots.List . add ( % Tempus.Slots.List { } , Tempus.Slot . wrap ( ~D|2020-08-07| ) ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } ] } iex&gt; % Tempus.Slots.List { } ...&gt; |&gt; Tempus.Slots.List . add ( Tempus.Slot . wrap ( ~D|2020-08-07| ) ) ...&gt; |&gt; Tempus.Slots.List . add ( Tempus.Slot . wrap ( ~D|2020-08-10| ) ) ...&gt; |&gt; Tempus.Slots.List . add ( % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] }","ref":"Tempus.Slots.List.html#add/3","title":"Tempus.Slots.List.add/3","type":"function"},{"doc":"Inverses Slots returning the new Slots instance with slots set where there were blanks. Example iex&gt; [ ~D|2020-08-07| , ~D|2020-08-08| , ~D|2020-08-10| , ~D|2020-08-12| ] ...&gt; |&gt; Enum . into ( % Tempus.Slots.List { } ) ...&gt; |&gt; Tempus.Slots.List . inverse ( ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : nil , to : ~U[2020-08-06 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-13 00:00:00.000000Z] , to : nil } ] } iex&gt; [ ...&gt; % Tempus.Slot { to : ~U[2020-08-08 23:59:59.999999Z] } , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { from : ~U[2020-08-12 00:00:00.000000Z] } ...&gt; ] |&gt; Enum . into ( % Tempus.Slots.List { } ) ...&gt; |&gt; Tempus.Slots.List . inverse ( ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } ] }","ref":"Tempus.Slots.List.html#inverse/2","title":"Tempus.Slots.List.inverse/2","type":"function"},{"doc":"Merges other into this slots instance. other might be Enum or Stream . When other is a stream, it gets terminated immediately after the last element in this . Examples iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots.List { } ) iex&gt; other = [ ...&gt; % Tempus.Slot { from : ~U|2020-08-07 23:00:00Z| , to : ~U|2020-08-08 12:00:00Z| } , ...&gt; % Tempus.Slot { from : ~U|2020-08-12 23:00:00Z| , to : ~U|2020-08-12 23:30:00Z| } ...&gt; ] iex&gt; Tempus.Slots . merge ( [ % Tempus.Slots { slots : slots } , other ] ) . slots % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 12:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 23:00:00Z] , to : ~U[2020-08-12 23:30:00Z] } ] } iex&gt; % Tempus.Slots { slots : slots } |&gt; Tempus.Slots . merge ( Tempus.Slots . wrap ( other , Tempus.Slots.Stream ) ) |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 12:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 23:00:00Z] , to : ~U[2020-08-12 23:30:00Z] } ]","ref":"Tempus.Slots.List.html#merge/3","title":"Tempus.Slots.List.merge/3","type":"function"},{"doc":"Splits the slots by the pivot given as a Slot.t or as a function. To keep it consistent, the function actually does split it until , which is intuitive when the pivot is given and kinda counter-intuitive when the locator function is given. See the examples below to grasp the reasoning behind this architectural decision. Examples iex&gt; import Tempus.Guards ...&gt; import Tempus.Sigils ...&gt; slots = ...&gt; [ ~D|2020-08-07| , ~D|2020-08-08| , ~D|2020-08-10| , ~D|2020-08-12| ] ...&gt; |&gt; Enum . into ( % Tempus.Slots.List { } ) ...&gt; slots |&gt; Tempus.Slots.List . split ( ~U|2020-08-09T12:00:00Z| ) { [ ~I(2020-08-07T00:00:00.000000Z → 2020-08-07T23:59:59.999999Z) , ~I(2020-08-08T00:00:00.000000Z → 2020-08-08T23:59:59.999999Z) ] , [ ~I(2020-08-10T00:00:00.000000Z → 2020-08-10T23:59:59.999999Z) , ~I(2020-08-12T00:00:00.000000Z → 2020-08-12T23:59:59.999999Z) ] } ...&gt; slots |&gt; Tempus.Slots.List . split ( &amp; is_coming_before ( ~U|2020-08-09T12:00:00Z| , &amp;1 ) ) { [ ~I(2020-08-07T00:00:00.000000Z → 2020-08-07T23:59:59.999999Z) , ~I(2020-08-08T00:00:00.000000Z → 2020-08-08T23:59:59.999999Z) ] , [ ~I(2020-08-10T00:00:00.000000Z → 2020-08-10T23:59:59.999999Z) , ~I(2020-08-12T00:00:00.000000Z → 2020-08-12T23:59:59.999999Z) ] }","ref":"Tempus.Slots.List.html#split/3","title":"Tempus.Slots.List.split/3","type":"function"},{"doc":"","ref":"Tempus.Slots.List.html#t:t/0","title":"Tempus.Slots.List.t/0","type":"type"},{"doc":"The default Stream implementation of Tempus.Slots ordered collection. Examples iex&gt; import Tempus.Slots.Stream , only : [ slots : 0 ] iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ] ...&gt; slots |&gt; Enum . into ( slots ( ) ) |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ] iex&gt; Enum . map ( slots , &amp; &amp;1 . from ) [ ~U[2020-08-07 00:00:00.000000Z] , ~U[2020-08-10 00:00:00.000000Z] , ~U[2020-08-07 01:00:00Z] ]","ref":"Tempus.Slots.Stream.html","title":"Tempus.Slots.Stream","type":"module"},{"doc":"Adds another slot to the slots collection backed by stream. Joins slots intersecting with the new one, if any. Example iex&gt; import Tempus.Slots.Stream , only : [ slots : 0 ] iex&gt; Tempus.Slots.Stream . add ( slots ( ) , Tempus.Slot . wrap ( ~D|2020-08-07| ) ) |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-07 23:59:59.999999Z] } ] iex&gt; % Tempus.Slots.Stream { } ...&gt; |&gt; Tempus.Slots.Stream . add ( Tempus.Slot . wrap ( ~D|2020-08-07| ) ) ...&gt; |&gt; Tempus.Slots.Stream . add ( Tempus.Slot . wrap ( ~D|2020-08-10| ) ) ...&gt; |&gt; Tempus.Slots.Stream . add ( % Tempus.Slot { ...&gt; from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ) ...&gt; |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 01:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } ]","ref":"Tempus.Slots.Stream.html#add/3","title":"Tempus.Slots.Stream.add/3","type":"function"},{"doc":"","ref":"Tempus.Slots.Stream.html#do_split_until/3","title":"Tempus.Slots.Stream.do_split_until/3","type":"function"},{"doc":"Inverses Slots returning the new Slots instance with slots set where there were blanks. Example iex&gt; [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-08| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-12| ) ...&gt; ] |&gt; Enum . into ( % Tempus.Slots.List { } ) ...&gt; |&gt; Tempus.Slots.List . inverse ( ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : nil , to : ~U[2020-08-06 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-13 00:00:00.000000Z] , to : nil } ] } iex&gt; [ ...&gt; % Tempus.Slot { to : ~U[2020-08-08 23:59:59.999999Z] } , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) , ...&gt; % Tempus.Slot { from : ~U[2020-08-12 00:00:00.000000Z] } ...&gt; ] |&gt; Enum . into ( % Tempus.Slots.List { } ) ...&gt; |&gt; Tempus.Slots.List . inverse ( ) % Tempus.Slots.List { slots : [ % Tempus.Slot { from : ~U[2020-08-09 00:00:00.000000Z] , to : ~U[2020-08-09 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-11 00:00:00.000000Z] , to : ~U[2020-08-11 23:59:59.999999Z] } ] }","ref":"Tempus.Slots.Stream.html#inverse/2","title":"Tempus.Slots.Stream.inverse/2","type":"function"},{"doc":"Produces a stream of slots wrapped in Tempus.Slots.Stream , ensuring the order of elements emitted. By default, slots will be joined if they are 1μsec aside.","ref":"Tempus.Slots.Stream.html#iterate/3","title":"Tempus.Slots.Stream.iterate/3","type":"function"},{"doc":"Merges other into this slots instance. other might be Enum or Stream . When other is a stream, it gets terminated immediately after the last element in this . Examples iex&gt; import Tempus.Slots.Stream , only : [ slots : 0 ] iex&gt; slots = [ ...&gt; Tempus.Slot . wrap ( ~D|2020-08-07| ) , ...&gt; Tempus.Slot . wrap ( ~D|2020-08-10| ) ...&gt; ] |&gt; Enum . into ( slots ( ) ) iex&gt; other = [ ...&gt; % Tempus.Slot { from : ~U|2020-08-07 23:00:00Z| , to : ~U|2020-08-08 12:00:00Z| } , ...&gt; % Tempus.Slot { from : ~U|2020-08-12 23:00:00Z| , to : ~U|2020-08-12 23:30:00Z| } ...&gt; ] |&gt; Enum . into ( slots ( ) ) iex&gt; slots |&gt; Tempus.Slots.Stream . merge ( other ) |&gt; Enum . to_list ( ) [ % Tempus.Slot { from : ~U[2020-08-07 00:00:00.000000Z] , to : ~U[2020-08-08 12:00:00Z] } , % Tempus.Slot { from : ~U[2020-08-10 00:00:00.000000Z] , to : ~U[2020-08-10 23:59:59.999999Z] } , % Tempus.Slot { from : ~U[2020-08-12 23:00:00Z] , to : ~U[2020-08-12 23:30:00Z] } ]","ref":"Tempus.Slots.Stream.html#merge/3","title":"Tempus.Slots.Stream.merge/3","type":"function"},{"doc":"Splits the slots by the pivot given as a Slot.t or as a function. To keep it consistent, the function actually does split it until , which is intuitive when the pivot is given and kinda counter-intuitive when the locator function is given. See the examples below to grasp the reasoning behind this architectural decision. Examples iex&gt; import Tempus.Guards ...&gt; import Tempus.Sigils ...&gt; slots = ...&gt; [ ~D|2020-08-07| , ~D|2020-08-08| , ~D|2020-08-10| , ~D|2020-08-12| ] ...&gt; |&gt; Enum . into ( % Tempus.Slots.Stream { } ) ...&gt; slots |&gt; Tempus.Slots.Stream . split ( ~U|2020-08-09T12:00:00Z| ) |&gt; Tuple . to_list ( ) |&gt; Enum . map ( &amp; Enum . to_list / 1 ) [ [ ~I(2020-08-07T00:00:00.000000Z → 2020-08-07T23:59:59.999999Z) , ~I(2020-08-08T00:00:00.000000Z → 2020-08-08T23:59:59.999999Z) ] , [ ~I(2020-08-10T00:00:00.000000Z → 2020-08-10T23:59:59.999999Z) , ~I(2020-08-12T00:00:00.000000Z → 2020-08-12T23:59:59.999999Z) ] ] ...&gt; slots ...&gt; |&gt; Tempus.Slots.Stream . split ( &amp; is_coming_before ( ~U|2020-08-09T12:00:00Z| , &amp;1 ) ) ...&gt; |&gt; Tuple . to_list ( ) ...&gt; |&gt; Enum . map ( &amp; Enum . to_list / 1 ) [ [ ~I(2020-08-07T00:00:00.000000Z → 2020-08-07T23:59:59.999999Z) , ~I(2020-08-08T00:00:00.000000Z → 2020-08-08T23:59:59.999999Z) ] , [ ~I(2020-08-10T00:00:00.000000Z → 2020-08-10T23:59:59.999999Z) , ~I(2020-08-12T00:00:00.000000Z → 2020-08-12T23:59:59.999999Z) ] ]","ref":"Tempus.Slots.Stream.html#split/3","title":"Tempus.Slots.Stream.split/3","type":"function"},{"doc":"","ref":"Tempus.Slots.Stream.html#t:t/0","title":"Tempus.Slots.Stream.t/0","type":"type"},{"doc":"Raised at runtime when an argument passed to function is invalid","ref":"Tempus.ArgumentError.html","title":"Tempus.ArgumentError","type":"exception"},{"doc":"Easy handling of time periods aka slots, like business days, holidays, etc.","ref":"readme.html","title":"Tempus","type":"extras"},{"doc":"def deps do [ { :tempus , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Tempus - Installation","type":"extras"},{"doc":"0.10.0 — complete rewrite of implementations, 3–10× faster, Slots form an Abelian group now 0.9.1 — Tempus.Sigils.parse/1 0.9.0 — Tempus.Guards , Tempus.slot/{1,2} , Tempus.guess/1 , better sigils, prepared for :tempus_sql 0.8.0 — improve Tempus.Sigils , prepared for :tempus_sql 0.7.3 — truncate: boolean() | non_neg_integer() to truncate Slots inspection 0.7.2 — Slots.merge/1 0.7.1 — treat infinite slot as special not-covering anything 0.7.0  —  merge/2 is 6× faster, Slot.neighbour?/2 , Tempus.slice/4 , Tempus.drop_while/2 , Tempus.take_while/2 0.6.0  — compatibility with Elixir v1.14 (no greek in variables names) meh 0.5.0  — stricter :telemetria support 0.4.2  — make :telemetria dependency fully optional 0.4.0  —  ~I sigil to ease slots creation, wrap date/times, fancy inspect 0.3.0  — drastical performance improvements, benchmarks 0.2.4  — fixed bug when finding next free/busy for empty slots 0.2.3  — correctly handle empty slots in next_busy/2 / next_free/2 0.2.2  —  Slot.shift_tz/3 0.2.1  — accept function as well as stream in Slots.merge/2 0.2.0  — many improvements, Tempus.add/2 similar to DateTime.add/4 but considering slots","ref":"readme.html#changelog","title":"Tempus - Changelog","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Tempus - Documentation","type":"extras"},{"doc":"","ref":"background.html","title":"Mathematical Background","type":"extras"},{"doc":"The pair of two elements is called a Slot if the following conditions are met each element is either nil or an instance of a datetime with defined timezone if both elements are datetimes, the first element does not superseed the second one if either element is nil , the Slot is called open , if both are nil , it’s called identity Slot id denoted [from → to] . Let’s define a binary union operation on slots, denoted ∪ . Slots do not form a group with ∪ , but sorted sets of slots of arbitrary length having no joint slots (denoted 𝕥 or more verbose 𝕥[[from₁, to₁], [from₂, to₂], …] ) do indeed form a group, denoted 𝕋 , together with a binary operation ∪ on 𝕋 , such as the following group axioms are satisfied: Associativity ∀ 𝕥₁, 𝕥₂, 𝕥₃ ∈ 𝕋, (𝕥₁ ∪ 𝕥₂) ∪ 𝕥₃ = 𝕥₁ ∪ (𝕥₂ ∪ 𝕥₃) Identity element ∃ 𝕥₀ ∈ 𝕋 ( 𝕥[] ) such that, for every 𝕥 in 𝕋, (𝕥 ∪ 𝕥₀) = (𝕥₀ ∪ 𝕥) = 𝕥 Inverse element For each 𝕥 in 𝕋, there exist 𝕥¯¹ such that 𝕥 ∪ 𝕥¯¹ = 𝕥¯¹ ∪ 𝕥 = 𝕥₀ That said, slots form an Abelian group with union binary operation and empty set as identity element.","ref":"background.html#%F0%9D%95%8Berminology","title":"Mathematical Background - 𝕋erminology","type":"extras"},{"doc":"Slots themselves form a semigroup with a binary union operation, an identity element [nil → nil] , without inverse.","ref":"background.html#slots-semigroup","title":"Mathematical Background - Slots Semigroup","type":"extras"},{"doc":"∀ 𝕥₁ = 𝕥[[from₁ → to₁]], 𝕥₂ = 𝕥[[from₂ → to₂]] ∈ 𝕋, 𝕥₁ ∪ 𝕥₂ is defined as 𝕥[[from₁ → to₁], [from₂ → to₂]] if to₁ &lt; from₂ 𝕥[[from₂ → to₂], [from₁ → to₁]] if to₂ &lt; from₁ 𝕥[[min(from₁, from₂) → max(to₁ → to₂)]] otherwise nil is considered to be less than any datetime and greater than any datetime, thus 𝕥[[nil → to₁]] ∪ 𝕥[[from₂ → to₂]] would be either 𝕥[[nil → max(to₁, to₂)]] if to₁ &gt; from₂ or 𝕥[[nil → to₁], [from₂ → to₂]] otherwise.","ref":"background.html#binary-operation","title":"Mathematical Background - Binary Operation","type":"extras"},{"doc":"Once 𝕋 is a group, each two elements of it might be merged . Even if they are infinite. That’s why Stream implementation of 𝕋 exists.","ref":"background.html#mergeability","title":"Mathematical Background - Mergeability","type":"extras"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Tempus library provides an easy way to handle and manipulate time slots. TYime slot is the base concept behind the library. It is basically the struct, containing from and to instances of DateTime . One might provide the list of slots, as Enum or as a Stream , and check whether another time slot and/or DateTime instance is overlapped or disjoined. Also one might get the next “available” slot(s) providing an origin , as well as next busy slot(s). It might be used e. g. to calculate the working days between now and some day in the future, providing the list of holidays, and the stream of weekends.","ref":"getting-started.html#usecases","title":"Getting Started - Usecases","type":"extras"},{"doc":"Tempus.Slots module leverages AVLTree . It exposes add/2 , merge/2 and inverse/2 functions to add slots, merge the slots with another slot(s) and/or Stream , and inverse the slots respecively. Typically one starts with something like slots = [ Tempus.Slot . wrap ( ~D|2020-08-07| ) , Tempus.Slot . wrap ( ~D|2020-08-10| ) , % Tempus.Slot { from : ~U|2020-08-07 01:00:00Z| , to : ~U|2020-08-08 01:00:00Z| } ] |&gt; Enum . into ( % Tempus.Slots { } ) When updated, Tempus.Slots joins the newly added slot(s) into the set of existing ones, so thet at any moment there is no overlapped slots. This happens when new slot is added with Tempus.Slots.add/2 and when the enumerable is collected. Consuming Streams Tempus.Slots is optimized for reads, that’s why internally it keeps slots as an Enum . It only allows to merge Stream into the existing Tempus.Slots and the stream will be terminated within the range of the Enum already presented. Below is the example of consuming the stream. holidays = [ ~D|2020-08-06| , ~D|2020-08-13| ] weekends = Stream . map ( [ ~D|2020-08-08| , ~D|2020-08-20| ] , &amp; &amp;1 ) schedule = holidays |&gt; Enum . into ( % Slots { } ) |&gt; Slots . merge ( weekends ) #⇒ #Slots&lt;[ # #Slot&lt;[ # from: ~U[2020-08-06 00:00:00.000000Z], # to: ~U[2020-08-06 23:59:59.999999Z] # ]&gt;, # #Slot&lt;[ # from: ~U[2020-08-08 00:00:00.000000Z], # to: ~U[2020-08-08 23:59:59.999999Z] # ]&gt;, # #Slot&lt;[ # from: ~U[2020-08-13 00:00:00.000000Z], # to: ~U[2020-08-13 23:59:59.999999Z] # ]&gt; # ]&gt;","ref":"getting-started.html#initializing-slots","title":"Getting Started - Initializing Slots","type":"extras"},{"doc":"With a help of Tempus.next_busy/2 and Tempus.next_free/2 , one might get the next busy and/or free slot(s). To calculate the first free slot in 5 business days after 2020-08-05 , the following is to be done. holidays = [ ~D|2020-08-07| , ~D|2020-08-13| ] # ... weekends = [ ~D|2020-08-08| , ~D|2020-08-09| ] # ... holidays |&gt; Enum . into ( % Slots { } ) |&gt; Tempus.Slots . merge ( weekends ) |&gt; Tempus . days_ahead ( ~D|2020-08-05| , 5 ) |&gt; hd ( ) #⇒ &quot;2020-08-14&quot;","ref":"getting-started.html#checking-state","title":"Getting Started - Checking State","type":"extras"}]